<%@ page contentType="text/html; charset=utf-8" %>
<%@ page language="java" %>
<%@ page pageEncoding="UTF-8" isErrorPage="true" %>
<% try { // START: DEBUG %>

<%@ page import="com.sas.apps.citation.util.CitationException" %>
<%@ page import="com.sas.apps.citation.view.beans.PagePropertyBean" %>
<%@ page import="com.sas.apps.citation.view.util.PageErrorProcessor" %>
<%@ page import="com.sas.apps.citation.view.tbeans.html.CitationButton" %>
<%@ page import="com.sas.apps.citation.util.PropertyHelper" %>


<%
   boolean isMissingCredential = (session.getAttribute(PageErrorProcessor.ERROR_IS_MISSING_CREDENTIAL)!=null);
   boolean isSuppressErrorDetails = PropertyHelper.getPropertyAsBool("wrs.suppressErrorDetails", false);	// (brcarb)
   
   
  String directionsMsg = (isSuppressErrorDetails) ? PagePropertyBean.getLabel(pageContext, "request.error.directions.suppress.details.txt") : PagePropertyBean.getLabel(pageContext, "request.error.directions.txt");
%>

<script type="text/javascript">
/* <![CDATA[*/
function cwManagePasswords () 
{ 
    openManagePasswordsDialog('openManagePasswords.do?dialogCommand=openDialog'); 
}
      
function openManagePasswordsDialog(dlgUrl) 
{
    cwDialogManager.openDialog(dlgUrl, 
                                cwDialogManager.MANAGE_PASSWORDS,   //dlgName
                                cwDialogManager.MANAGE_PASSWORDS,   //dlgFeatures
                                true, //bReplaceUrl
                                true, //bModal
                                false //bReplaceIfOpen
                                );
}
/*]]>*/
</script>

<table border="0" cellspacing="0" cellpadding="0" width="100%" summary="" >
    <tr><td class="linePadding">&nbsp;</td></tr>
    <tr><td class="linePadding">&nbsp;</td></tr>
    <tr><td class="linePadding">&nbsp;</td></tr>
    <tr><td class="linePadding">&nbsp;</td></tr>
    <tr><td class="linePadding">&nbsp;</td></tr>
    <tr><td class="linePadding">&nbsp;</td></tr>
    <tr><td class="linePadding">&nbsp;</td></tr>
    <tr><td class="linePadding">&nbsp;</td></tr>
    <tr>
        <td align="center">
            <table border="0" cellspacing="0" cellpadding="0" summary="" >
                <tr>
                    <td class="errorMessages">
                        <%=PagePropertyBean.getLabel(pageContext, "request.error.txt")%>
                    </td>
                </tr>
            </table>
        </td>
    </tr>
    <tr><td class="linePadding">&nbsp;</td></tr>
    <tr><td class="linePadding">&nbsp;</td></tr>
    <tr><td class="linePadding">&nbsp;</td></tr>
    <tr>
        <td align="center" class="label">
            <%
               if (isMissingCredential) {
            %>
                            
                <%=PagePropertyBean.getLabel(pageContext, "error.render.view.element.missing.credential.error.page.txt")%>
            <%
               } else {
            %>
                <%=directionsMsg%>
            <%
               }
            %>
        
        </td>
    </tr>
    <tr><td class="linePadding">&nbsp;</td></tr>
    <tr><td class="linePadding">&nbsp;</td></tr>
    <tr><td class="linePadding">&nbsp;</td></tr>
    <tr>
        <td align="center">
            <table border="0" cellspacing="0" cellpadding="0" summary="" >
                <tr>
                
            <%
               if (isMissingCredential) {
            %>
            
                    <td>
<%
CitationButton managePasswordsButton = CitationButton.createStandaloneButton(request, "managePasswordsButton",
    PagePropertyBean.getLabel(pageContext,"menubar.file.manage.passwords.txt"),
    "javascript:cwManagePasswords();");
managePasswordsButton.setFocus(true);
managePasswordsButton.write(out);
%>
                    </td>
                    <td class="buttonSpacer">&nbsp;</td>
                    <td class="buttonSpacer">&nbsp;</td>
            <%
               }
            %>
                    <td>
<%

if (! isSuppressErrorDetails)	// (brcarb)
{
	CitationButton detailsButton = CitationButton.createStandaloneButton(request, "detailsButton",
    	PagePropertyBean.getLabel(pageContext,"request.error.details.txt"),
    	"javascript:openGenericDialog('RequestError','errorDetails.do');");
	detailsButton.write(out);
}

%>
                    </td>
                    <td class="buttonSpacer">&nbsp;</td>
                    <td class="buttonSpacer">&nbsp;</td>
                    <td>
<%
CitationButton closeButton = CitationButton.createStandaloneButton(request, "closeButton",
    PagePropertyBean.getLabel(pageContext,"request.error.close.txt"),
    "javascript:closeErrorsWindow();");
closeButton.setFocus(!isMissingCredential);
closeButton.write(out);
%>
                    </td>
                </tr>
            </table>
        </td>
    </tr>
</table>
<% if (PageErrorProcessor.getReportErrorSummary(session) == null
       && PageErrorProcessor.getReportErrorDetail(session) == null) 
   { %>
        <script type="text/javascript"> /*<![CDATA[*/   
        closeErrorsWindow();
        /*]]>*/ </script>        
<% } %>
<% } catch (Exception ex) { // MIDDLE: DEBUG
    System.out.println(PagePropertyBean.getMessage(pageContext, "request.error.fatal.txt"));
    ex.printStackTrace();

    // generate stack trace & stash in session.
    StringBuffer trace = new StringBuffer(500)
        .append("<h3>")
        .append(PagePropertyBean.getMessage(pageContext, "request.error.fatal.txt"))
        .append("</h3>")
        .append("<pre>");               // honor newlines in stack trace.
    CitationException.generateStackTrace(ex, trace);
    trace.append("</pre>");
    out.println(trace.toString());
} // END: DEBUG %>
